
(defun Info-update-header-line-window ()
  (interactive)
  (let ((win-orig (selected-window))
        (win-header-line
         (get-window-with-predicate
          (lambda (window)
            (equal (buffer-name (window-buffer window))
                   " *Info-header-line*")))))
    (if win-header-line
        (select-window win-header-line)
      (setq win-orig (split-window-vertically))
      (switch-to-buffer (get-buffer-create " *Info-header-line*")))
    (erase-buffer)
    (fit-window-to-buffer nil 2 1)
    (setq window-size-fixed 'height)
    (setq mode-line-format nil)
    (setq cursor-type nil truncate-lines t)
    (set (make-local-variable 'face-remapping-alist)
	 '((default header-line)))
    (insert (with-selected-window win-orig
              (concat (get-text-property (point-min) 'header-line)
		      "\n"
                      (buffer-substring
                       (save-excursion (goto-char (point-min))
                                       (forward-line 1) (point))
                       (save-excursion (goto-char (point-min))
                                       (forward-line 2) (point))))))
    (goto-char (point-min))
    (select-window win-orig)))

(defadvice Info-fontify-node (around my-Info-fontify-node act)
  ad-do-it
  (Info-update-header-line-window))
